#!/usr/local/bin/ruby


require 'cgi'
require 'rubygems'
require "orbjson"
require 'logger'

include Orbjson


$logger = Logger.new( "orbjson_cgi.log" )

# Change this to ERROR or something when your code does 
# all it should, and does it right:
$logger.level = Logger::DEBUG 


$logger.debug( "Have a request!" )

# You can configure the Orbjsn services list in a few ways.
# Well, three, really:
#  1. Pass in a path to a local YAML file; the path must begin with
#   'file://'
#     For example: cfg = 'file://config.yaml'
#     json_rpc = CGI_JSON_RPC.new( cfg )
#     
#  2. Pass in some YAML:   
#    cfg = 'services/sample: 
#            - Details'
#    json_rpc = CGI_JSON_RPC.new( cfg )
#            
#  3. Pass in some an atual Hash objectL:   
#    cfg = { 'services/sample' => ['Details'] }
#    json_rpc = CGI_JSON_RPC.new( cfg )
#
#  The hash (however you express it) consists of 'require' paths mapped
#  to arrays of classes to instantiate.


# Change this to suit your actual situation:
cfg = 'services/sample: 
   - Details'
json_rpc = CGI_JSON_RPC.new( cfg )

print "content-type: text/javascript\n\n"
res =  json_rpc.process_request
$logger.debug( "Have a response:\n#{res}" ) 
# Logging may make an already slow CGI app go
# even slower, so consider dropping this suf when things are good.

print res








